package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@OptIn(ExperimentalUnsignedTypes::class)
class U64(provider: DatabaseType.Provider) :
	DatabaseType._VirtualType<ULong, UByteArray, DatabaseType.BINARY_DATA>(provider.BINARY_DATA(8u, true)) {

	override val name: String get() = "INT_U64"

	override fun _unwrap(w: UByteArray): ULong {
		var result = w[0].toULong() shl 56
		result = result or (w[1].toULong() and 0xFFuL shl 48)
		result = result or (w[2].toULong() and 0xFFuL shl 40)
		result = result or (w[3].toULong() and 0xFFuL shl 32)
		result = result or (w[4].toULong() and 0xFFuL shl 24)
		result = result or (w[5].toULong() and 0xFFuL shl 16)
		result = result or (w[6].toULong() and 0xFFuL shl 8)
		return result or (w[7].toULong() and 0xFFuL)
	}

	override fun _wrap(w: ULong): UByteArray {
		val dst = UByteArray(8)
		dst[0] = (w shr 56).toUByte()
		dst[1] = (w shr 48).toUByte()
		dst[2] = (w shr 40).toUByte()
		dst[3] = (w shr 32).toUByte()
		dst[4] = (w shr 24).toUByte()
		dst[5] = (w shr 16).toUByte()
		dst[6] = (w shr 8).toUByte()
		dst[7] = w.toUByte()
		return dst
	}

	override fun _equals(l: ULong, r: ULong): Boolean = l == r

	override fun _compare(l: ULong, r: ULong): Int = l.compareTo(r)

}