package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.db.serdha0.api.module.CreateModuleScope
import ru.landgrafhomyak.db.serdha0.api.module.ModuleTemplate

@Suppress("ClassName", "MemberVisibilityCanBePrivate")
class M_V0 private constructor(context: CreateModuleScope) {
	val chats = context.createTable(context.rootNs, "chats", T_Chats)
	val users = context.createTable(context.rootNs, "users", T_Users)
	val queueSets = context.createTable(context.rootNs, "queue_sets", T_QueueSets(this.chats))
	val queues = context.createTable(context.rootNs, "queue", T_Queues(this.queueSets))
	val user2queue = context.createTable(context.rootNs, "user->queue", T_User2Queue(this.users, this.queueSets, this.queues))
	val moderators = context.createTable(context.rootNs, "moderators", T_Moderators(this.users, this.chats))

	companion object Constructor : ModuleTemplate.ModuleConstructor<M_V0> {
		override fun createSchema(context: CreateModuleScope) = M_V0(context)
	}
}